//+------------------------------------------------------------------+
//|                                                      BW-Zone.mq4 |
//|                                              2009, SVK Software |
//|                                                                  |
//+------------------------------------------------------------------+
//mod2009fxtsd macs&osma var

#property copyright " 2009, SVK Software"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 Gray
#property indicator_color4 Gray

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

//---- buffers
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];

double macdBuff[];
double osmaBuff[];
double osmacdBuff[];
double osmacdsigBuff[];

extern int    macdFast_MA      = 5;
extern int    macdSlow_MA      = 34;
extern int    macdSig_MA       = 5;

extern int    osmaFast_MA      = 5;
extern int    osmaSlow_MA      = 34;
extern int    osmaSig_MA       = 5;

extern string   note_Price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";
extern string   MA_Method_ = "SMA0 EMA1 SMMA2 LWMA3";



extern int    macdFast_MA_Method      = 0;
extern int    macdSlow_MA_Method      = 0;
extern int    macdSig_MA_Method       = 0;

extern int    macdFast_MA_Price      = 5;
extern int    macdSlow_MA_Price      = 5;

extern int    osmaFast_MA_Method      = 0;
extern int    osmaSlow_MA_Method      = 0;
extern int    osmaSig_MA_Method       = 0;

extern int    osmaFast_MA_Price      = 5;
extern int    osmaSlow_MA_Price      = 5;









int    BarsCount;
int    Length = 100;
int    limit;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   IndicatorBuffers(8);

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,UpBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnBuffer1);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,UpBuffer2);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,DnBuffer2);

   SetIndexBuffer(4,macdBuff);
   SetIndexBuffer(5,osmacdBuff);
   SetIndexBuffer(6,osmacdsigBuff);
   SetIndexBuffer(7,osmaBuff);
   
   int maxper=MathMax(macdSlow_MA,osmaSlow_MA);
   for(int b=0;b<=indicator_buffers;b++) SetIndexDrawBegin (b,maxper);


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
            limit=Bars-counted_bars;
            
            
    for(i=limit;i>=0;i--) 
    {   
    macdBuff[i]=  iMA(NULL,0,macdFast_MA,0,macdFast_MA_Method,macdFast_MA_Price,i)-
                  iMA(NULL,0,macdSlow_MA,0,macdSlow_MA_Method,macdSlow_MA_Price,i);
                
               
    osmacdBuff[i]=iMA(NULL,0,osmaFast_MA,0,osmaFast_MA_Method,osmaFast_MA_Price,i)-
                  iMA(NULL,0,osmaSlow_MA,0,osmaSlow_MA_Method,osmaSlow_MA_Price,i);
     }   
               
                      
    for(i=limit;i>=0;i--) 
    {
      osmacdsigBuff[i]=iMAOnArray(osmacdBuff,0,osmaSig_MA,0,osmaSig_MA_Method,i);
      osmaBuff[i]= osmacdBuff[i]-osmacdsigBuff[i];



   
       UpBuffer1[i] =EMPTY_VALUE;
       DnBuffer1[i] =EMPTY_VALUE;
       UpBuffer2[i] =EMPTY_VALUE; 
       DnBuffer2[i] =EMPTY_VALUE;


       if (macdBuff[i] > macdBuff[i+1] && osmaBuff[i] > osmaBuff[i+1])
         {
          UpBuffer1[i] = High[i];
          DnBuffer1[i] = Low[i];
         }
       else   
       if (macdBuff[i] < macdBuff[i+1] && osmaBuff[i] < osmaBuff[i+1])
         {
          UpBuffer1[i] = Low[i];
          DnBuffer1[i] = High[i];       
         }

       else   
         {
          UpBuffer2[i] = High[i];
          DnBuffer2[i] = Low[i];
          UpBuffer1[i] =EMPTY_VALUE;
          DnBuffer1[i] =EMPTY_VALUE;


         }

      } 
//----
   return(0);
  }
//+------------------------------------------------------------------+